;;;; macosx-url.scm
;;;; Kon Lovett, Sep '06

(declare
  (no-procedure-checks)
  (no-bound-checks)
	(export
		macosx:open-url) )

#>
#import <ApplicationServices/ApplicationServices.h>
#import <CoreFoundation/CoreFoundation.h>

static int
open_url (const char *urlstr, int len)
{
	OSStatus    sta = 1;
	CFURLRef    url = CFURLCreateWithBytes (NULL, (const UInt8 *) urlstr, len, kCFStringEncodingASCII, NULL);
	if (NULL != url) {
		sta = LSOpenCFURLRef (url, NULL);
		CFRelease (url);
	}
	return sta;
}
<#

(define (macosx:open-url url)
	(let ([sta ($ int open_url (c-string url) (int (string-length url)))])
	  (unless (fx= 0 sta)
	    (error 'macosx:open-url "OSStatus" sta) ) ) )
